#include <iostream>
#include <assert.h>
#include "string.h"
#include "map.h"
#include "vector.h"

typedef map<vector<unsigned>,string> ForwardMap;
typedef map<string,vector<vector<unsigned>>> BackwardMap;

void readKey(vector<unsigned>& rRes) {
    while (true) {
        int i;
        std::cin >> i;
        if (i < 0)
            return;
        else
            rRes.push_back(i);
    }
}

void insert(ForwardMap& rF,BackwardMap& rB) {
    vector<unsigned> key;
    readKey(key);
    string s;
    std::cin >> s;
    rF.insert(key,s);
    vector<vector<unsigned>>* res = rB.find(s);
    if (res == nullptr)
        rB.insert(s,{key});
    else
        res->push_back(key);
}

void search(const ForwardMap& crF,const BackwardMap& crB) {
    vector<unsigned> key;
    readKey(key);
    string* res = crF.find(key);
    if (res != nullptr) {
        vector<vector<unsigned>>* res2 = crB.find(*res);
        std::cout << *res << " " << res2->size() << std::endl;
        for(unsigned ui1 = 0;ui1 < res2->size();++ui1) {
            for(unsigned ui2 = 0;ui2 < (*res2)[ui1].size();++ui2)
                std::cout << (*res2)[ui1][ui2] << " ";
            std::cout << std::endl;
        }
    }
}

int main() {
    ForwardMap m1;
    BackwardMap m2;
    while(true) {
        unsigned cmd = 0;
        std::cin >> cmd;
        switch (cmd) {
        case 1: insert(m1,m2);break;
        case 2: search(m1,m2);break;
        default: return 0;
        }
    }
    return 0;
}