#pragma once //__SEMESTERAUFGABE_MAP_H__

template<typename K, typename V>
class map {
    public:
    
        class Node {
            public:
                friend class map;
                
                Node (K key, V value):
                m_kKey(key),
                m_vValue(value)
                {
                }

                Node (const Node& crArg) :
                    m_kKey(crArg.m_kKey),
                    m_vValue(crArg.m_vValue),
                    m_npLeft(crArg.m_npLeft != nullptr ? new Node (*crArg.m_npLeft) : nullptr),
                    m_npRight(crArg.m_npRight != nullptr ? new Node (*crArg.m_npRight) : nullptr)
                {
                }

                ~Node () {
                    // Delete auf Nullptr gibt keinen Fehler
                    delete m_npLeft;
                    delete m_npRight;
                }

                Node& operator= (const Node crArg) = delete;

            private:
                K m_kKey;
                V m_vValue;
                Node* m_npLeft = nullptr;
                Node* m_npRight = nullptr;
        };

        map () = default;

        map (const map& crArg) :
            m_nRoot(crArg.m_nRoot != nullptr ? new Node (*crArg.m_nRoot) : nullptr) {
        }

        ~map () {
            delete m_nRoot;
        }

        V* find (K key) const {
            Node* res = m_nRoot;
            while (res != nullptr) {
                if (res->m_kKey < key) {
                    res = res->m_npRight;
                } else if (key < res->m_kKey) {
                    res = res->m_npLeft;
                } else {
                    return &(res->m_vValue);
                }
            }
            return nullptr;
        }

        void insert (const K& key, const V& data) {
            m_nRoot = insert (m_nRoot, key, data);
        }

        map<K, V>& operator= (map<K, V> crArg){
            Node* tmp = crArg.m_nRoot;
            crArg.m_nRoot = m_nRoot;
            m_nRoot = tmp;

            return *this;  
        }

    private:
        Node* recSearch (const K& key, Node* n) const {
            if (n == nullptr) {
                return nullptr;
            } else {
                if (key < n->m_kKey) {
                    return recSearch(key, n->m_kKey);
                } else if (n->m_kKey < key) {
                    return recSearch(key, n->m_kKey);
                } else {
                    return n;
                }
            }
        }

        Node* insert (Node* n, const K& key, const V& data) {
            if (n == nullptr) { 
                return new Node(key, data);
            } else {
                if (key < n->m_kKey) {
                    n->m_npLeft = insert(n->m_npLeft, key, data);
                } else if (n->m_kKey < key) {
                    n->m_npRight = insert(n->m_npRight, key, data);
                }
                return n;
            }
        }

        Node* m_nRoot = nullptr;
};
