#include "string.h"
#include <iostream>

string::string (const char* string) :
    m_cpString(new char[string::calcSize(string)+1])
{
    unsigned i = 0;
    for ( ; *string != '\0'; ++i, ++string) {
        m_cpString[i] = *string;
    }
    m_cpString[i] = '\0'; // Char-Arrays, die im heap erzeugt werden, bekommen nicht automatisch '\0' angehangen
}

string::string (const string& crArg) :
    m_cpString(new char[string::calcSize(crArg.m_cpString)+1])
{
    unsigned size = string::calcSize(crArg.m_cpString);
    for (unsigned i = 0; i < size; ++i) {
        m_cpString[i] = crArg.m_cpString[i]; 
    } 
    m_cpString[size] = '\0';
}

string::~string () {
    delete[] m_cpString;
}

std::ostream &operator<< (std::ostream& os, const string& crArg) {
    os << crArg.m_cpString;
    return os;
}

std::istream &operator>> (std::istream& is, string& crArg) {
    char* tmp = new char[100];
    is >> tmp;
    unsigned size = string::calcSize(tmp);
    delete[] crArg.m_cpString;
    crArg.m_cpString = new char[size+1];
    for (unsigned i = 0; i < size; ++i) {
        crArg.m_cpString[i] = tmp[i]; 
    } 
    crArg.m_cpString[size] = '\0';

    delete[] tmp;
    return is;
}

string& string::operator= (const string& crArg) { // TODO: Dreieckstausch?
    if (this == &crArg) {
        return *this;
    } 
    
    delete[] m_cpString;
    unsigned size = string::calcSize(crArg.m_cpString);
    m_cpString = new char[size+1];
    for (unsigned i = 0; i < size; ++i) {
        m_cpString[i] = crArg.m_cpString[i]; 
    } 
    m_cpString[size] = '\0';
    return *this;   
}

bool string::operator< (const string& crArg) const {
    for (unsigned i = 0; *(m_cpString + i) != '\0' && *(crArg.m_cpString + i) != '\0'; ++i) {
        if (*(m_cpString + i) < *(crArg.m_cpString + i)) {
            return true;
        } else if (*(m_cpString + i) > *(crArg.m_cpString + i)) {
            return false;
        }
    }
    return (string::calcSize(m_cpString) < string::calcSize(crArg.m_cpString));
}

unsigned string::calcSize (const char* string) {
    unsigned res = 0;
    while (*string != '\0') { // calcSize erwartet keinen nullptr, ist Anwenderfehler... string != nullptr &&
        ++res;
        ++string;
    }
    return res;
}