#pragma once //__SEMESTERAUFGABE_VECTOR_H__

#include <iostream>

template<typename T>
class vector {
    public:
        vector (unsigned initialCapacity = 1, unsigned capacityIncrement = 0) :
            m_tArr(new T[initialCapacity]),
            m_cuCapacityIncrement(capacityIncrement),
            m_uCapacity(initialCapacity)
        {
        }

        vector (const T& variable) :
            m_tArr(new T[1]),
            m_cuCapacityIncrement(0),
            m_uCapacity(1),
            m_uSize(1)
        {
            m_tArr[0] = variable;
        }

        vector (const vector<T>& crArg) :
            m_tArr(new T[crArg.m_uCapacity]),
            m_cuCapacityIncrement(crArg.m_cuCapacityIncrement),
            m_uCapacity(crArg.m_uCapacity),
            m_uSize(crArg.m_uSize)
        {
            for (unsigned i = 0; i < m_uSize; ++i) {
                *(m_tArr+i) = *(crArg.m_tArr+i); 
            }
        }

        ~vector () {
            delete[] m_tArr;
        }

        void push_back (T value) {
            if (m_uSize >= m_uCapacity) {
                resize();
            }
            m_tArr[m_uSize++] = value;
        }

        unsigned size () const {
            return m_uSize;
        }

        const T& operator[] (const unsigned index) const {
            return m_tArr[index];
        }

        T& operator[] (const unsigned index) {
            return m_tArr[index];
        }

        bool operator< (const vector& crArg) const {
            unsigned ssize = (this->m_uSize < crArg.m_uSize ? this->m_uSize : crArg.m_uSize);
            for (unsigned i = 0; i < ssize; ++i) {
                if (*(m_tArr + i) < *(crArg.m_tArr + i)) {
                    return true;
                } else if (*(m_tArr + i) > *(crArg.m_tArr + i)) {
                    return false;
                }
            }
          
            return this->m_uSize < crArg.m_uSize;
        }

        vector<T>& operator= (const vector<T>& crArg) {
            if (this == &crArg) {
                return *this;
            } 

            delete[] m_tArr;
            unsigned size = crArg.m_uCapacity;
            m_tArr = new T[size];
            for (unsigned i = 0; i < size; ++i) {
                *(m_tArr+i) = *(crArg.m_tArr+i); 
            } 
            m_cuCapacityIncrement = crArg.m_cuCapacityIncrement;
            m_uCapacity = crArg.m_uCapacity;
            m_uSize = crArg.m_uSize;

            return *this;  
        }

    private:
        void resize () {
            unsigned newCapacity = m_uCapacity + (m_cuCapacityIncrement == 0 ? m_uCapacity : m_cuCapacityIncrement);
             T* tmp = new T[newCapacity];
             for (unsigned i = 0; i < m_uCapacity; ++i) {
                     *(tmp+i) = *(m_tArr+i);
             }
             delete[] m_tArr;
             m_tArr = tmp;
             m_uCapacity = newCapacity;
        }

        T* m_tArr;
        unsigned m_cuCapacityIncrement = 0;
        unsigned m_uCapacity = 1;
        unsigned m_uSize = 0;
};