#include <iostream>
#include <assert.h>
#include "string.h"
#include "map.h"
#include "vector.h"

typedef map<vector<unsigned>,string> ForwardMap;
typedef map<string,vector<vector<unsigned>>> BackwardMap;

void readKey(vector<unsigned>& rRes) {
    while (true) {
        int i;
        std::cin >> i;
        if (i < 0)
            return;
        else
            rRes.push_back(i);
    }
}

void insert(ForwardMap& rF,BackwardMap& rB) {
    vector<unsigned> key;
    readKey(key);
    string s;
    std::cin >> s;
    rF.insert(key,s);
    vector<vector<unsigned>>* res = rB.find(s);
    if (res == nullptr)
        rB.insert(s,{key});
    else
        res->push_back(key);
}

void search(const ForwardMap& crF,const BackwardMap& crB) {
    vector<unsigned> key;
    readKey(key);
    string* res = crF.find(key);
    if (res != nullptr) {
        vector<vector<unsigned>>* res2 = crB.find(*res);
        std::cout << *res << " " << res2->size() << std::endl;
        for(unsigned ui1 = 0;ui1 < res2->size();++ui1) {
            for(unsigned ui2 = 0;ui2 < (*res2)[ui1].size();++ui2)
                std::cout << (*res2)[ui1][ui2] << " ";
            std::cout << std::endl;
        }
    }
}

int main() {
    ForwardMap m1;
    BackwardMap m2;
    while(true) {
        unsigned cmd = 0;
        std::cin >> cmd;
        switch (cmd) {
        case 1: insert(m1,m2);break;
        case 2: search(m1,m2);break;
        default: return 0;
        }
    }
    return 0;
}

/*
Das Programm liest von der Tastatur Zahlen und Wörter ein und gibt wiederum Zahlen und Wörter auf der Konsole aus. Als Beispiel können die Dateien input.txt und input2.txt als Eingabe verwendet werden. Diese produzieren Ausgaben, die Sie in ouput.txt bzw. output2.txt finden.

Ihre Aufgabe besteht daran, die fehlenden Datenstrukturen zu implementieren, d.h. Sie müssen die Klassen vektor, map und string implementieren. Die Klassen vektor und map sind Templates, die Klasse string nicht. Dazu müssen Sie drei Headerdateien "map.h", "vektor.h" und "string.h" erstellen. Die Implementierung der string Klasse soll in der Implementationsdatei string.cpp erfolgen, die beiden Templates vektor und map werden in den entsprechenden Header Dateien definiert. Die map soll durch einen binären Suchbaum implementiert werden.

WICHTIG: das vorgegebene Programm darf nicht verändert werden, auch dürfen Sie keine weiteren vordefinierte Klassen oder Funktionen verwenden.

Die Abgabe des gesamten Programms mit allen Header- und Implementationsdateien hat im ZIP Format zu erfolgen. Nach dem Entpacken muss im Root-Verzeichnis des Archivs eine Makefile-Datei existieren, so dass das Programm mittels make unter Linux erzeugbar ist. Schalten beim Kompilieren die Warnungsoptionen -Wall -Weffc++ -Wextra -pedantic -Wfatal-errors -pedantic-errors ein. Testen Sie Ihr Programm mit valgrind. Es dürfen durch valgrind keine Fehler oder Speicherleaks angezeigt werden.

*/